package com.community.huiju.controller;

import com.aliyun.oss.OSSClient;
import io.swagger.annotations.*;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.ByteArrayInputStream;
import java.util.Date;

/**
 * @author weichaochao
 * @Title: ImageController
 * @Description: 图片上传以及获取url
 * @date 2018/10/31
 */
@RestController
@RefreshScope
@RequestMapping("/")
@Api(value = "图片操作API", description = "图片操作API")
public class ImageController {

    private static String endpoint = "http://oss-cn-hangzhou.aliyuncs.com";
    private static String accessKeyId = "LTAIiG6xeHbVzTXC";
    private static String accessKeySecret = "YUci8oBtm5WzobH6SP2eyZUbjCBKBo";
    private static String bucketName = "imgurlspace";

    @ApiOperation(value = "图片上传以及获取url", notes = "图片上传以及获取url")
    @PostMapping(value = "/getUrl", consumes = "multipart/*", headers = "content-type=multipart/form-data")
    public String uploadImgAndGetUrl(@ApiParam(value = "file" ,required = true) MultipartFile uploadFile) throws Exception {

        String imgName = System.currentTimeMillis() + ".png";
        // 创建OSSClient实例
        OSSClient ossClient = new OSSClient(endpoint, accessKeyId, accessKeySecret);
        // 上传
        long time = System.currentTimeMillis();

        ossClient.putObject(bucketName, imgName, new ByteArrayInputStream(uploadFile.getBytes()));
        // 关闭client
        ossClient.shutdown();
        Date expiration = new Date(time + 3600 * 1000 * 24 * 365 * 10);
        String url = ossClient.generatePresignedUrl(bucketName, imgName, expiration).toString();
        return url;
    }
}
